﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Input;

namespace BaseTileManager
{
    // This Relay Command implementation can be used in WPF
    //public class RelayCommand<T> : ICommand
    //{
    //    #region Fields

    //    readonly Action<T> _execute = null;
    //    readonly Predicate<T> _canExecute = null;

    //    #endregion // Fields

    //    public RelayCommand(Action<T> execute)
    //        : this(execute, null)
    //    {
    //    }

    //    public RelayCommand(Action<T> execute, Predicate<T> canExecute)
    //    {
    //        if (execute == null)
    //            throw new ArgumentNullException("execute");

    //        _execute = execute;
    //        _canExecute = canExecute;
    //    }

        
    //    #region ICommand Members

    //    public bool CanExecute(object parameter)
    //    {
    //        return _canExecute == null ? true : _canExecute((T)parameter);
    //    }

    //    public event EventHandler CanExecuteChanged
    //    {
    //        add { CommandManager.RequerySuggested += value; }
    //        remove { CommandManager.RequerySuggested -= value; }
    //    }

    //    public void Execute(object parameter)
    //    {
    //        _execute((T)parameter);
    //    }

    //    #endregion // ICommand Members

    //}

    public class RelayCommand: ICommand
    {
        public event EventHandler CanExecuteChanged;

        Predicate<Object> _canExecute = null;
        Action<Object> _executeAction = null;

        public RelayCommand( Action<object> executeAction,Predicate<Object> canExecute)
        {
            _canExecute = canExecute;
            _executeAction = executeAction;
        }
        public bool CanExecute(object parameter)
        {
            if (_canExecute != null)
                return _canExecute(parameter);
            return true;
        }

        public void UpdateCanExecuteState()
        {
            if (CanExecuteChanged != null)
                CanExecuteChanged(this, new EventArgs());
        }

        public void Execute(object parameter)
        {
            if (_executeAction != null)
                _executeAction(parameter);
            UpdateCanExecuteState();
        }
    }

}
