﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace BaseTileManager
{
    public class User 
    { 
        private static Random r = new Random(); 
        string[] appointments = { "Out of office", "Busy", "Free", "Meeting", "?" }; 
        string[] descriptions = { "This is important when dealing...", "Important... take into account!...", "Perhaps the best insurance..." }; 
        public User(string name) { Name = name; 
            Schedule = new ObservableCollection<string>(); 
            Details = new ObservableCollection<string>(); 
            for (int i = 0; i < 8; i++)
            { 
                Schedule.Add(string.Format("{0:00}:00 - {1}", 8 + i, 
                    appointments[r.Next(0, appointments.Length)])); 
                Details.Add(string.Format("{0} \r\n {1}", Schedule[i], 
                    descriptions[r.Next(0, descriptions.Length)]));
            } 
        } 
        public string Name { get; set; } 
        public ObservableCollection<string> Schedule { get; set;} 
        public ObservableCollection<string> Details { get; set; } 
    }
    public class ViewModel : INotifyPropertyChanged
    {
        public ObservableCollection<User> Users { get; set; }
        private ICommand mainBtnCmd; private ICommand itemBtnCmd;
        private string msg;
        public ICommand MainBtnCmd
        {
            get
            {
                if (mainBtnCmd == null)
                {
                    mainBtnCmd = new RelayCommand(MainBtnCmdExe, CanMainBtnCmdExe);
                }
                return mainBtnCmd;
            }
        }
        public ICommand ItemBtnCmd
        {
            get
            {
                if (itemBtnCmd == null)
                {
                    itemBtnCmd = new RelayCommand(ItemBtnCmdExe, CanItemBtnCmdExe);
                }
                return itemBtnCmd;
            }
        }
        public string Message
        {
            get { return msg;  }
            set
            {
                if (msg != value)
                {
                    msg = value;
                    OnPropertyChanged("Message");
                }
            }
        }
        public ViewModel()
        {
            Users = new ObservableCollection<User>();

            for (int i = 0; i < 10; i++)
                Users.Add(new User("User " + i.ToString()));
        }

        private void MainBtnCmdExe(object parameter)
        {
            Message = "Main Button Clicked";
        }
        private bool CanMainBtnCmdExe(object parameter)
        {
            return true;
        }
        private void ItemBtnCmdExe(object parameter)
        {
            User user = parameter as User;
            Message = "Tile for user " + user.Name + " clicked";


        }
        private bool CanItemBtnCmdExe(object parameter)
        {
            return true;
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        private void OnPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }
        #endregion
    }
   
}
